//	This is a DEMO driver program 
//
//	Ivo Dinov, UCLA School of Medicine and Departments
//	of Mathematics and Statistics
//	Jan. 15, 2004
//	Version 1.0

#include <myDemoHeader.h>

int main(int argc, char **argv)
{	int i, size=1;
	char y_n;
	UnSignedCharStar myByteArray;  	
				// UnSignedCharStar[Y_dim][X_dim], Y-slowly varying and X-fast
				// varying indices. You must read these and cast to integers 
				// from command line using the "atoi(argv[k])" function  

		// Instantiation (Definition and memory allocation) of array
	dimensions = initialization(argc, argv, number_dims);

	for (int i = 0; i < number_dims; i++)
			size *= dimensions[i];

	myByteArray = new unsigned char[size];
        for (i = 0; i < number_dims; i++)
			myByteArray[i] = 0;

	cout << "CALL_2_myDemoIO_readIn::number_dims=" << number_dims << endl;
    	myDemoIO(argv[1], myByteArray, number_dims, dimensions, 'r');
	cerr << "CALL_2_myDemoFIlter!!!" << endl;
	cout << "CALL_2_myDemoIO_readIn::number_dims=" << number_dims << endl;
	myDemoFilter(myByteArray, number_dims, dimensions);
	cout << "CALL_2_myDemoIO_writeOut!!!" << endl;
	cout << "CALL_2_myDemoIO_readIn::number_dims=" << number_dims << endl;
	myDemoIO(argv[2], myByteArray, number_dims, dimensions, 'w');
	cout << "CALL_2_myDemoIO_WRITE_OUT::number_dims=" << number_dims << endl;

		// Release memory back to system
	delete [] myByteArray;
	delete [] dimensions;

	cout << "Okay? (y/n)" <<endl;
    	cin >> y_n;

    return 0;
}

